uses mydos;

const
  t_l2a_xor: Array[0..7] of Byte = ($80, $80, $80, $20,  $80, $80, $A0, $00);

var
  f2: File of Byte;
  sr: SearchRec;
  cc: LongInt;
  bb: Byte;


//    xx yy:xx xx xx xx xx xx xx xx    
procedure coding(const s: String);
var b: Byte; l, i: LongInt; hs: String;

begin
  b := $80; write(f2, b);
  for l := 0 to 9 do begin
    hs := '$' + copy(s, l*3 + 1, 2);
    val(hs, b, i); if i <> 0 then RunError(22);
    write(f2, b);
  end;
end;


procedure process(const fn: String);
var f1: Text; s: String; b: Byte; l: LongInt;
begin
  writeln(fn);
  if Length(fn) > 29 then RunError(33);

  b := ord(fn[1]) and $0F;			//  
  write(f2, b);

  for l := 3 to Length(fn) do begin		//  
    b := ord(fn[l]);
    b := b xor t_l2a_xor[b shr 5];
    write(f2, b);
  end;
  b := 0; write(f2, b);

  assign(f1, 'Macros/' + SR.name); reset(f1);	//   
  while not eof(f1) do begin
    readln(f1, s);
    if Length(s) > 30 then RunError(44);

    if s = '' then begin				//  
      b := Byte(^X); write(f2, b);
      continue;
    end;

    if (length(s) = 29) and (s[6] = ':') then begin	//     
      coding(s);
      continue;
    end;

    l := 1;
    while True do begin
      if s[l] = '\' then begin
        b := Byte(^X); write(f2, b);
        break;
      end;

      b := ord(s[l]);
      b := b xor t_l2a_xor[b shr 5];
      write(f2, b);

      inc(l);
      if l > Length(s) then begin
        b := 13; write(f2, b);
	break;
      end;
    end;

  end;    
  close(f1);

  b := 0; write(f2, b);				//  
end;


begin
  assign(f2, 'ps2agatKBD.macro'); rewrite(f2);

  bb := $FF;
  for cc := 1 to $800*2 do write(f2, bb);

  FindFirst('Macros/*', 0, SR);

  While DosError = 0 do begin
    if SR.name[1] in ['0', '7', '9'] then process(SR.name);
    FindNext(SR);
  end;

  FindClose(SR);
  close(f2);
end.
